package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.CasetaPeajeExcepcionDAO;
import com.rjconsultores.ventaboletos.entidad.CasetaPeaje;
import com.rjconsultores.ventaboletos.entidad.CasetaPeajeExcepcion;

@Repository("casetaPeajeExcepcionDAO")
public class CasetaPeajeExcepcionHibernateDAO extends GenericHibernateDAO<CasetaPeajeExcepcion, Integer> implements CasetaPeajeExcepcionDAO {

	@Autowired
	public CasetaPeajeExcepcionHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@Override
	public List<CasetaPeajeExcepcion> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

		return c.list();
	}

	@Override
	public List<CasetaPeajeExcepcion> obtenerPorCasetaPeaje(CasetaPeaje caseta) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq("casetaPeaje", caseta));
		c.add(Restrictions.eq(ACTIVO, true)).setResultTransformer(Criteria.DISTINCT_ROOT_ENTITY);

		return c.list();
	}
}
